package v2;

import java.awt.*;

/**
 * Created with IntelliJ IDEA.
 * User: Vladimir
 * Date: 31.5.2013
 * Time: 16:27
 */
public class Acrob {
    private static final int SIZE = 10;
    private float scale = 1f;
    private double x,y;
    private float rotation = 0;
    public static final float WHEEL_DIFFERENCE = 11;
    public static final float ROTATION_CENTER = 3;
    public static final float SENSOR_DIFFERENCE = 1.7f;
    public static final float PATH_WIDTH = 2;
    public static final float FRONT_SENSOR = 4;
    public static final float RADIUS = 1.1f;

    public float getScale() {
        return scale;
    }

    public void setScale(float scale) {
        this.scale = scale;
    }

    public double getX() {
        return x;
    }

    public void setX(double x) {
        this.x = x;
    }

    public double getY() {
        return y;
    }

    public void setY(double y) {
        this.y = y;
    }

    public float getRotation() {
        return rotation;
    }

    public void setRotation(float rotation) {
        this.rotation = rotation;
    }

    public void draw(Graphics g){
        g.setColor(Color.decode("0x047880"));
        g.fillRect((int)((x-SIZE)*scale),(int)((y-SIZE)*scale),(int)(2*SIZE*scale),(int)(2*SIZE*scale));
        g.setColor(Color.LIGHT_GRAY);
        g.fillOval((int)((x-RADIUS)*scale),(int)((y-RADIUS)*scale),(int)(2*RADIUS*scale),(int)(2*RADIUS*scale));
        drawSensor(g, (int) ((x + (ROTATION_CENTER + FRONT_SENSOR)*Math.cos(rotation) * scale)), (int) ((y - Math.sin(rotation)*(ROTATION_CENTER + FRONT_SENSOR) * scale)));
        drawSensor(g, (int) ((x + (ROTATION_CENTER)*Math.cos(rotation) * scale)), (int) ((y - Math.sin(rotation) * (ROTATION_CENTER)* scale)));
        drawSensor(g, (int) (( (SENSOR_DIFFERENCE)*Math.sin(rotation) + x + Math.cos(rotation) * (ROTATION_CENTER) * scale)), (int) ((Math.cos(rotation)*(SENSOR_DIFFERENCE) + y - Math.sin(rotation) *(ROTATION_CENTER) * scale)));
        drawSensor(g, (int) ((-Math.sin(rotation)*(SENSOR_DIFFERENCE) + x + Math.cos(rotation) * (ROTATION_CENTER) * scale)), (int) ((-Math.cos(rotation)*(SENSOR_DIFFERENCE) + y - Math.sin(rotation) *(ROTATION_CENTER) * scale)));

        g.setColor(Color.RED);
        g.drawLine((int)x, (int)y, (int)(x + Math.cos(rotation) * 200), (int)(y + Math.sin(rotation) * 200));
    }

    private void drawSensor(Graphics g, float xx, float yy){
        g.setColor(Color.ORANGE);
        g.fillOval((int)((xx-RADIUS)*scale),(int)((yy-RADIUS)*scale),(int) (RADIUS*2*scale),(int) (RADIUS*2*scale));
    }

}
