package v2;

import java.util.HashMap;

/**
 * Created with IntelliJ IDEA.
 * User: Vladimir
 * Date: 6.6.2013
 * Time: 17:47
 */
public class Actions {

    private static final double FORWARD_SPEED = 1;

    private static final HashMap<Integer, Action> actions = new HashMap<Integer, Action>();

    private static final Action ERROR_ACTION  = new Action() {
            @Override
        public String getName() {
            return "error action";
        }

        @Override
        public double getSpeed() {
            return 0;  //To change body of implemented methods use File | Settings | File Templates.
        }

        @Override
        public double getDegRotation() {
            return 0;  //To change body of implemented methods use File | Settings | File Templates.
        }
    };

    private static final Action FORWARD_ACTION = new Action() {
        @Override
        public String getName() {
            return "forward";
        }

        @Override
        public double getSpeed() {
            return FORWARD_SPEED;
        }

        @Override
        public double getDegRotation() {
             return 0;
        }
    };

    private static final Action R_ROTATE_ACTION  = new Action() {
        @Override
        public String getName() {
            return "right rotate action";
        }

        @Override
        public double getSpeed() {
            return 0;  //To change body of implemented methods use File | Settings | File Templates.
        }

        @Override
        public double getDegRotation() {
            return 90;  //To change body of implemented methods use File | Settings | File Templates.
        }
    };
    private static final Action L_ROTATE_ACTION  = new Action() {
        @Override
        public String getName() {
            return "left rotate action";
        }

        @Override
        public double getSpeed() {
            return 0;  //To change body of implemented methods use File | Settings | File Templates.
        }

        @Override
        public double getDegRotation() {
            return -90;  //To change body of implemented methods use File | Settings | File Templates.
        }
    };

    private static final Action R_FORWARD_ACTION  = new Action() {
        @Override
        public String getName() {
            return "R forward action";
        }

        @Override
        public double getSpeed() {
            return FORWARD_SPEED/20;  //To change body of implemented methods use File | Settings | File Templates.
        }

        @Override
        public double getDegRotation() {
            return 60;  //To change body of implemented methods use File | Settings | File Templates.
        }
    };

    private static final Action L_FORWARD_ACTION  = new Action() {
        @Override
        public String getName() {
            return "L forward action";
        }

        @Override
        public double getSpeed() {
            return FORWARD_SPEED/20;  //To change body of implemented methods use File | Settings | File Templates.
        }

        @Override
        public double getDegRotation() {
            return -60;  //To change body of implemented methods use File | Settings | File Templates.
        }
    };


    static {
        actions.put(1, FORWARD_ACTION);
        actions.put(2, R_ROTATE_ACTION);
        actions.put(3, L_ROTATE_ACTION);
        actions.put(4, R_FORWARD_ACTION);
        actions.put(5, L_FORWARD_ACTION);
    }

    public static final Action fromBitVector(Integer vec){
        Action action = actions.get(vec);
        if(action == null){
            return ERROR_ACTION;
        }
        System.out.print(vec + " ");
        return action;
    }

}
