package v2;

import java.beans.Transient;
import java.util.List;

/**
 * Created with IntelliJ IDEA.
 * User: Vladimir
 * Date: 6.6.2013
 * Time: 17:30
 */
public class Brain {

    private List<Sensor> sensors;

    private double x, y;

    private double rot;

    private double v, va;

    private NeuralNetwork neuralNetwork;

    public void setRot(double rot) {
        this.rot = rot;
    }

    public NeuralNetwork getNeuralNetwork() {
        return neuralNetwork;
    }

    public String sensorOutput(){
        StringBuffer buffer = new StringBuffer();
        for(Sensor sensor:getSensors()){
            buffer.append(sensor.getName());
            buffer.append(": ");
            buffer.append(1-sensor.percept());
            buffer.append(" ");
        }
        return buffer.toString();
    }

    /**
     * don't kill me
     * @return
     */
    @Transient
    public String debug(){
         return "x = "+x+"\ty = "+y+"\trot = "+Math.toDegrees(rot)+"\tv = "+v+"\t va = "+va;
    }

    public void setNeuralNetwork(NeuralNetwork neuralNetwork) {
        this.neuralNetwork = neuralNetwork;
    }

    public void update(Floor floor, float tpf){
        System.out.println(x);
        System.out.println(100 * v * Math.cos(rot) * tpf);
        System.out.println(x + 100 * v * Math.cos(rot) * tpf);
        x += 100 * v * Math.cos(rot) * tpf;
        y += 100 * v * Math.sin(rot) * tpf;
        rot += va * tpf;

        for(Sensor sensor : sensors){
            sensor.setX(x + sensor.getDx() * Math.cos(rot) - sensor.getDy() * Math.sin(rot));
            sensor.setY(y + sensor.getDx() * Math.sin(rot) + sensor.getDy() * Math.cos(rot));
            sensor.set(floor.get(sensor.getX(), sensor.getY()));
        }

        Action action = neuralNetwork.forwardFeed(sensors);
        System.out.println(action + " SENSORS " + sensorOutput());
        v = action.getSpeed();
        va = Math.toRadians(action.getDegRotation());
    }

    public double getX() {
        return x;
    }

    public void setX(int x) {
        this.x = x;
    }

    public double getRot() {
        return rot;
    }

    public double getY() {
        return y;
    }

    public void setY(int y) {
        this.y = y;
    }

    public List<Sensor> getSensors() {
        return sensors;
    }

    public void setSensors(List<Sensor> sensors) {
        this.sensors = sensors;
    }
}
