package v2;

import org.ejml.simple.SimpleMatrix;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

/**
 * Created with IntelliJ IDEA.
 * User: Vladimir
 * Date: 6.6.2013
 * Time: 17:47
 */
public class EvaluatedBehaviorNetwork implements NeuralNetwork {

    private static final double LINE_TRESHOLD = 0.5;

    private SimpleMatrix THETA_1 = Akokolvek.getTheta1();

    private SimpleMatrix THETA_2 = Akokolvek.getTheta2();

    /*    private SimpleMatrix THETA_3 = new SimpleMatrix(
                new double[][]{

                }
        );
      */
    @Override
    public Action forwardFeed(List<Sensor> sensors) {
        List<Integer> bitVector = mapInput(sensors);
        Integer output = feed(bitVector);

        return Actions.fromBitVector(output);
    }

    private List<Integer> mapInput(List<Sensor> sensors) {
        List<Integer> result = new ArrayList<Integer>();
        for (Sensor sensor : sensors) {
            result.add(sensor.percept() < LINE_TRESHOLD ? 1 : 0);
        }
        return result;
    }

    int last = 1;

    public Integer feed(List<Integer> input) {
        if (last != 1 && (input.equals(Arrays.asList(0, 0, 0, 0))   || input.equals(Arrays.asList(1, 1, 1, 0 ))  )) {
            return last;
        }

        SimpleMatrix x = new SimpleMatrix(1, input.size());
        for (int i = 0; i < input.size(); i++) {
            x.set(0, i, input.get(i));
        }

         /*
        SimpleMatrix a1 = Eye.matrix(1).combine(1, 0, new SimpleMatrix(x));

        SimpleMatrix z2 = a1.mult(THETA_1.transpose());
        SimpleMatrix a2 = Sigmoid.apply(z2);

        SimpleMatrix z3 = (Eye.matrix(1).combine(1, 0, a2)).mult(THETA_2);
        // SimpleMatrix a3 = Sigmoid.apply(z3);

        // SimpleMatrix z4 = THETA_3.mult(Eye.matrix(1).combine(1, 0, a3));

        SimpleMatrix result = Sigmoid.apply(z3);

        int index = 0;
        double max = result.get(index);

        for (int i = 1; i < result.numCols(); i++) {
            if (result.get(i) > max) {
                max = result.get(i);
                index = i;
            }
        }
        return index+1;*/


        int m = 1;
        int num_labels = THETA_2.numRows(); //size(Theta2, 1);

        SimpleMatrix ones = new SimpleMatrix(m, 1);
        for (int i = 0; i < m; i++) {
            ones.set(i, 0, 1);
        }

        SimpleMatrix tmp0 = ones.combine(0, 1, x).mult(THETA_1.transpose());
        SimpleMatrix h1 = Sigmoid.apply(ones.combine(0, 1, x).mult(THETA_1.transpose()));
        SimpleMatrix a1 = ones.combine(0, 1, h1);

        SimpleMatrix tmp = ones.combine(0, 1, h1).mult(THETA_2.transpose());
        SimpleMatrix h2 = Sigmoid.apply(ones.combine(0, 1, h1).mult(THETA_2.transpose()));
        //        [dummy, p] = max(h2, [], 2);

        SimpleMatrix result = h2;

        int index = 0;
        double max = result.get(index);

        for (int i = 1; i < result.numCols(); i++) {
            if (result.get(i) > max) {
                max = result.get(i);
                index = i;
            }
        }
        last = index + 1;
        return index + 1;

    }


}
