package v2;

import javax.imageio.ImageIO;
import javax.swing.*;
import java.awt.*;
import java.awt.image.BufferedImage;
import java.io.File;
import java.io.IOException;
import java.util.Arrays;

/**
 * Created with IntelliJ IDEA.
 * User: Vladimir
 * Date: 31.5.2013
 * Time: 16:27
 */
public class VWindow extends JFrame {

    final Brain brain = new Brain();

    private Acrob acrob = new Acrob();

    {
        acrob.setX(300);
        acrob.setY(300);
        acrob.setRotation((float) Math.toRadians(180));


    }

    public JPanel panel = new JPanel() {
        BufferedImage background;
        {
            try {
                background = ImageIO.read(new File("maze0.bmp"));
            } catch (IOException e) {
                e.printStackTrace();
            }
        }
        @Override
        protected void paintComponent(Graphics g) {
            super.paintComponent(g);
            g.drawImage(background, 0, 0, null);
            acrob.draw(g);
            g.setColor(Color.BLACK);
            g.drawString(brain.sensorOutput(), 10, 10);
            g.setColor(Color.GREEN);
            g.fillOval((int)brain.getSensors().get(0).getX() -2 , (int)brain.getSensors().get(0).getY() - 2, 4,4);

            g.setColor(Color.BLUE);
            g.fillOval((int)brain.getSensors().get(2).getX() -2 , (int)brain.getSensors().get(2).getY() - 2, 4,4);

        }
    };

    public static void main(String... args) {
        final VWindow window = new VWindow();
        window.add(window.panel);
        window.setSize(800, 600);
        window.setVisible(true);
        window.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);

        final ImageBasedFloor floor = new ImageBasedFloor();

        Sensor left = new Sensor();
        left.setName("left");
        Sensor right = new Sensor();
        right.setName("right");
        Sensor front = new Sensor();
        front.setName("front");

        Sensor center = new Sensor();
        center.setName("center");

        left.setDx(3);
        left.setDy(-1.7);


        front.setDx(3 + 4);

        right.setDx(3);
        right.setDy(1.7);

        center.setDx(3);

        final Brain brain = window.brain;
        brain.setSensors(Arrays.asList(left, center, right, front));
     //   brain.setX(242);
      //  brain.setY(200);
      //  brain.setRot(-180);

        brain.setX(304);
        brain.setY(188);
        brain.setRot(-180);

        EvaluatedBehaviorNetwork network = new EvaluatedBehaviorNetwork();
        brain.setNeuralNetwork(network);
        floor.init(new File("maze0.bmp"));
        new Thread(new Runnable() {
            @Override
            public void run() {
                while (true) {
                    brain.update(floor, 0.01f);
                    window.acrob.setX(brain.getX());
                    window.acrob.setY(brain.getY());
                    window.acrob.setRotation((float) brain.getRot());
                    window.panel.repaint();
                    System.out.println(brain.debug());
                    try {
                        Thread.sleep(12);
                    } catch (InterruptedException e) {
                        e.printStackTrace();
                    }
                }
            }
        }).start();
    }
}
